您的位置:首页 > 其它

LeetCode之“链表”:Intersection of Two Linked Lists

2015-06-26 15:46 507 查看
  此题扩展:链表有环,如何判断相交?

  参考资料:

    编程判断两个链表是否相交

    面试精选:链表问题集锦

  题目链接

  题目要求:

  Write a program to find the node at which the intersection of two singly linked lists begins.

  For example, the following two linked lists:

  A:          a1 → a2
  ↘
  c1 → c2 → c3
  ↗
  B:     b1 → b2 → b3

  begin to intersect at node c1.

  Notes:

If the two linked lists have no intersection at all, return
null
.

The linked lists must retain their original structure after the function returns.

You may assume there are no cycles anywhere in the entire linked structure.

Your code should preferably run in O(n) time and use only O(1) memory.

  Credits:
  Special thanks to @stellari for adding this problem and creating all test cases.

  这道题即是求两个链表交点的典型题目。具体地,我们可以这样子做:

  1)求得两个链表的长度;

  2)将长的链表向前移动|lenA - lenB|步;

  3)两个指针一起前进,遇到相同的即是交点,如果没找到,返回nullptr。

  具体程序如下:

/**
* Definition for singly-linked list.
* struct ListNode {
*     int val;
*     ListNode *next;
*     ListNode(int x) : val(x), next(NULL) {}
* };
*/
class Solution {
public:
ListNode *getIntersectionNode(ListNode *headA, ListNode *headB) {
if(!headA || !headB)
return nullptr;

int lenA = 0, lenB = 0;
ListNode *startA = headA, *startB = headB;
while(startA)
{
lenA++;
startA = startA->next;
}

while(startB)
{
lenB++;
startB = startB->next;
}

startA = headA;
startB = headB;
if(lenA > lenB)
{
for(int i = 0; i < lenA - lenB; i++)
startA = startA->next;
}
else
{
for(int i = 0; i < lenB - lenA; i++)
startB = startB->next;
}

while(startA && startB)
{
if(startA == startB)
return startA;
startA = startA->next;
startB = startB->next;
}

return nullptr;
}
};


  附上该题作者分析

  There are many solutions to this problem:

Brute-force solution (O(mn) running time, O(1) memory):
For each node ai in list A, traverse the entire list B and check if any node in list B coincides with ai.

Hashset solution (O(n+m) running time, O(n) or O(m) memory):
Traverse list A and store the address / reference to each node in a hash set. Then check every node bi in list B: if bi appears in the hash set, then bi is the intersection node.

Two pointer solution (O(n+m) running time, O(1) memory):

Maintain two pointers pA and pB initialized at the head of A and B, respectively. Then let them both traverse through the lists, one node at a time.

When pA reaches the end of a list, then redirect it to the head of B (yes, B, that's right.); similarly when pB reaches the end of a list, redirect it the head of A.

If at any point pA meets pB, then pA/pB is the intersection node.

To see why the above trick would work, consider the following two lists: A = {1,3,5,7,9,11} and B = {2,4,9,11}, which are intersected at node '9'. Since B.length (=4) < A.length (=6), pB would reach the end of the merged list first, because pB traverses exactly 2 nodes less than pA does. By redirecting pB to head A, and pA to head B, we now ask pB to travel exactly 2 more nodes than pA would. So in the second iteration, they are guaranteed to reach the intersection node at the same time.

If two lists have intersection, then their last nodes must be the same one. So when pA/pB reaches the end of a list, record the last element of A/B respectively. If the two last elements are not the same one, then the two lists have no intersections.

  Analysis written by @stellari.
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: